package org.act.od.impl.view.editor {
  import mx.binding.utils.BindingUtils;
  import mx.binding.utils.ChangeWatcher;
  import mx.containers.Canvas;

  import org.ow2.orchestra.designer.bpmn.model.ProcessModel;
  import org.ow2.orchestra.designer.bpmn.views.ProcessView;
  import org.ow2.orchestra.designer.model.DesignerModelLocator;
  import org.ow2.orchestra.designer.model.ProcessEditorModel;

  /**
   * Microimage is used for lay out the canvas in the micro view.
   */
  public class Microimage extends Canvas {

    private static var microimage:Microimage = new Microimage();

    private var processView:ProcessView = null;

    private var changeWatcher:ChangeWatcher = null;

    public function Microimage() {
      super();

      this.setStyle("backgroundColor", "0xffffff");

      this.percentHeight = 100;
      this.percentWidth = 100;


      // Active the tab matching to the selected process
      BindingUtils.bindSetter(setSelectedProcessEditor, DesignerModelLocator.getInstance(), "selectedProcessEditor");
    }

    /**
     * Active the tab matching to the selected process
     */
    private function setSelectedProcessEditor(selectedProcessEditor:ProcessEditorModel):void {
      if (changeWatcher != null) {
        changeWatcher.unwatch();
      }
      if (selectedProcessEditor != null) {
        if (changeWatcher == null) {
          changeWatcher = BindingUtils.bindSetter(setSelectedProcess, selectedProcessEditor, "processModel");
        } else {
          changeWatcher.reset(selectedProcessEditor);
        }
        setSelectedProcess(selectedProcessEditor.processModel);
      } else {
        setSelectedProcess(null);
      }
    }

    /**
     * Active the tab matching to the selected process
     */
    private function setSelectedProcess(selectedProcess:ProcessModel):void {
      this.removeAllChildren();
      if (selectedProcess != null) {
        processView = new ProcessView(selectedProcess);
        this.addChild(processView);
      }
    }

    public static function getInstance():Microimage {
      return microimage;
    }

    override protected function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void {
      super.updateDisplayList(unscaledWidth, unscaledHeight);
      if (processView != null) {
        if (width < processView.width || height < processView.height) {
          var v_scaleX:Number = width / processView.width;
          var v_scaleY:Number = height / processView.height;
          var scale:Number = Math.min(v_scaleX, v_scaleY);
          this.scaleX = scale;
          this.scaleY = scale;
        } else {
          this.scaleX = 1;
          this.scaleY = 1;
        }
      }
    }
  }
}
