/**
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2010 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.commands {
import com.adobe.cairngorm.commands.ICommand;
import com.adobe.cairngorm.control.CairngormEvent;

import org.ow2.orchestra.designer.events.ProcessSelectionElementCoordinatesChangeEvent;
import org.ow2.orchestra.designer.view.processEditor.ElementCoordinatesUpdate;

public class MoveSelectedElementsCMD implements ICommand {

  public function MoveSelectedElementsCMD() {
  }

  public function execute(event:CairngormEvent):void {
    var processSelElCoordEvt:ProcessSelectionElementCoordinatesChangeEvent = event
            as ProcessSelectionElementCoordinatesChangeEvent;

    // save process model
    processSelElCoordEvt.processEditorModel.saveModelForUndo();

    for each (var elementMove:ElementCoordinatesUpdate in processSelElCoordEvt.elementsMove) {
      elementMove.elementModel.x += elementMove.deltaX;
      elementMove.elementModel.y += elementMove.deltaY;
    }
  }
}
}
