/*
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2011 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


package org.ow2.orchestra.designer.view.fileNavigator {
import mx.controls.treeClasses.TreeItemRenderer;
import mx.controls.treeClasses.TreeListData;

import org.ow2.orchestra.designer.model.DesignerModelLocator;
import org.ow2.orchestra.designer.vo.FileNavigatorProcess;

/**
 * Created by IntelliJ IDEA.
 * User: diouf-a
 * Date: 10/06/11
 * Time: 17:18
 * To change this template use File | Settings | File Templates.
 */
public class SharedProcessesTreeItemRenderer extends TreeItemRenderer {


  public function SharedProcessesTreeItemRenderer() {
    super();
  }

  override protected function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void {

    var treeListData:TreeListData = TreeListData(this.listData);

    super.updateDisplayList(unscaledWidth, unscaledHeight);
    if (super.data is TreeItem && TreeItem(super.data).itemData is FileNavigatorProcess) {

      var process:FileNavigatorProcess = TreeItem(super.data).itemData as FileNavigatorProcess;
      if (!treeListData.hasChildren && process.project.owner.name != DesignerModelLocator.getInstance().userName) {
        this.label.text = process.project.name + "/" + process.name + " by " + process.project.owner.name;

      }
    }
  }
}
}
