/**
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2010 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.view.processEditor {
import org.ow2.orchestra.designer.bpmn.model.AbstractElementWithPosition;

/**
 * <p>This class hold a coordinates update for an
 * {@link org.ow2.orchestra.designer.bpmn.model.AbstractElementWithPosition} </p>
 * <p>
 * Note: The model is not directly updated within this class. It will be later updated
 * with values held by this class using default Cairngorm MVC model.</p>
 *
 * @author Loic Albertin
 */
public class ElementCoordinatesUpdate {

  private var _elementModel:AbstractElementWithPosition;
  private var _deltaX:int = 0;
  private var _deltaY:int = 0;

  public function ElementCoordinatesUpdate(model:AbstractElementWithPosition) {
    this._elementModel = model;
  }

  /**
   * The corresponding element model
   */
  public function get elementModel():AbstractElementWithPosition {
    return _elementModel;
  }

  /**
   * The delta from the element position on x-coordinate
   */
  public function get deltaX():int {
    return _deltaX;
  }

  public function set deltaX(value:int):void {
    _deltaX = value;
  }

  /**
   *  The delta from the element position on y-coordinate
   */
  public function get deltaY():int {
    return _deltaY;
  }

  public function set deltaY(value:int):void {
    _deltaY = value;
  }
}
}
