/*
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2011 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

/**
 * @author Loic Albertin
 */
package org.ow2.orchestra.designer.view.properties {
import com.adobe.cairngorm.CairngormError;
import com.adobe.cairngorm.CairngormMessageCodes;

import mx.core.UIComponent;

import org.ow2.orchestra.designer.bpmn.model.AbstractElement;
import org.ow2.orchestra.designer.model.DesignerModelLocator;

public class AbstractProperty implements IProperty {
  protected var _propertyName:String;
  protected var _description:String;

  public function AbstractProperty(propertyName:String, description:String) {
    _propertyName = propertyName;
    _description = description;
  }

  public function get description():String {
    return _description;
  }

  public function get itemEditor():UIComponent {
    //This method is designed to be abstract
    throw new CairngormError(CairngormMessageCodes.ABSTRACT_METHOD_CALLED);
  }

  public function get itemRenderer():UIComponent {
    //This method is designed to be abstract
    throw new CairngormError(CairngormMessageCodes.ABSTRACT_METHOD_CALLED);
  }

  protected function getSelectedElement():AbstractElement {
    var element:AbstractElement;
    if (DesignerModelLocator.getInstance().selectedProcessEditor.selectedElements.length == 1) {
      element = DesignerModelLocator.getInstance().selectedProcessEditor.selectedElements.getItemAt(0) as AbstractElement;
    } else if (DesignerModelLocator.getInstance().selectedProcessEditor.selectedElements.length == 0) {
      element = DesignerModelLocator.getInstance().selectedProcessEditor.processModel;
    } else {
      return null;
    }
    return element;
  }
}
}
